///home/berryj/link/bin/genMethods "-g" "-t" "DBinGraph" "-r" "MDBinGraph" "-I" "LINK/graph/DBinGraph.h" "-y" "display_graph" "-w" "free_graph" "-d" "graph" "-f" "_dBinGraph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/DBinGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graph(SCM, SCM, int);
void free_graph(SCM);

typedef DBinGraph _DBinGraph;

#define _DBinGraphDATA(x) ((DBinGraph*) (EXTDATA(x)))
#define _DBinGraphIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<DBinGraph >::type))
#define _DBinGraphISNT_DATA(x) (!_DBinGraphIS_DATA(x))

#define _DBinGraphCXX_DATA(x) (*(DBinGraph*) (EXTDATA(VAL(x))))
#define _DBinGraphCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<DBinGraph >::type))
#define _DBinGraphCXX_ISNT_DATA(x) (!_DBinGraphCXX_IS_DATA(x))


PRIMITIVE STk_init__dBinGraph()
{
	Wrapper<_DBinGraph>::type = STk_new_CXXwrapper_id(
			Wrapper<_DBinGraph>::name, 
			Wrapper<MDBinGraph >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graph,
			(void (*)(SCM x))0,
			(void (*)(SCM x))free_graph);
	Tcl_InitHashTable(&Register<_DBinGraph>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_dBinGraphMethods(void);

PRIMITIVE STk_init_methods__dBinGraph()
{
	genExtra_dBinGraphMethods();
	return UNDEFINED;
}
